<?php

class ActionSquadro {
    private $plateau;

    public function __construct(PlateauSquadro $plateau) {
        $this->plateau = $plateau;
    }

    public function testJouablePiece($x, $y) {
        $piece = $this->plateau->getPiece($x, $y);
        if ($piece->getCouleur() === PieceSquadro::VIDE) {
            return false;
        }
        list($newX, $newY) = $this->plateau->getCoordDestination($x, $y);
        return $this->plateau->getPiece($newX, $newY)->getCouleur() === PieceSquadro::VIDE;
    }

    public function jouePiece($x, $y) {
        if (!$this->testJouablePiece($x, $y)) {
            return;
        }
        $piece = $this->plateau->getPiece($x, $y);
        list($newX, $newY) = $this->plateau->getCoordDestination($x, $y);
        $this->plateau->setPiece($piece, $newX, $newY);
        $this->plateau->setPiece(PieceSquadro::initVide(), $x, $y);
        if ($this->plateau->getPiece($newX, $newY)->getCouleur() === PieceSquadro::BLANC && $newY === 6) {
            $piece->inverseDirection();
        } elseif ($this->plateau->getPiece($newX, $newY)->getCouleur() === PieceSquadro::NOIR && $newX === 0) {
            $piece->inverseDirection();
        }
    }

    public function reculePiece($x, $y) {
        $piece = $this->plateau->getPiece($x, $y);
        if ($piece->getCouleur() === PieceSquadro::BLANC) {
            $this->plateau->setPiece($piece, $x, 0);
        } else {
            $this->plateau->setPiece($piece, 6, $y);
        }
    }

    public function sortPiece($couleur, $rang) {
        foreach ($this->plateau->getPlateau() as $i => $row) {
            foreach ($row as $j => $piece) {
                if ($piece->getCouleur() === $couleur && $piece->getDirection() === PieceSquadro::NORD) {
                    $this->plateau->setPiece(PieceSquadro::initVide(), $i, $j);
                    return;
                }
            }
        }
    }

    public function remporteVictoire($couleur) {
        $count = 0;
        foreach ($this->plateau->getPlateau() as $row) {
            foreach ($row as $piece) {
                if ($piece->getCouleur() === $couleur && $piece->getDirection() === PieceSquadro::NORD) {
                    $count++;
                }
            }
        }
        return $count >= 4;
    }
}
?>